Imports System.io
Imports SpeechLib

Public Class SKSpeechEventArgs
    Inherits System.EventArgs
    'FPꐔ
    Public RecoCount As Integer = 0
    '[
    Public RuleName As String = ""
    'lf[^
    Public values() As Integer
    'f[^
    Public Words() As String
    'vpeB
    Public ItemName() As String
    'RXgN^iFPꐔwj
    Public Sub New(ByVal Count As Integer)
        ReDim values(Count)
        ReDim Words(Count)
        ReDim ItemName(Count)
        RecoCount = Count
    End Sub
End Class


Public Class MiraiSpeech
    'FIuWFNg
    Private objRecoContext As SpeechLib.SpSharedRecoContext
    'F@
    Private grammar As ISpeechRecoGrammar
    'FʂԂCxgNǂ̃tO
    Private RecoEnabled As Boolean = True
    'FʂԂtO
    Public Event Recognition(ByVal sender As Object, ByVal e As SKSpeechEventArgs)

    'RecoEnabledpvpeB
    Public Property Enabled() As Boolean
        Get
            Return RecoEnabled
        End Get
        Set(ByVal Value As Boolean)
            RecoEnabled = Value
            If RecoEnabled Then
                grammar.CmdSetRuleIdState(0, SpeechRuleState.SGDSActive)
            Else
                grammar.CmdSetRuleIdState(0, SpeechRuleState.SGDSInactive)
            End If
        End Set
    End Property


    Public Sub New(ByVal FNM As String)
        'Grammert@C邩ǂׂ
        If File.Exists(FNM) = False Then
            Throw New ApplicationException("Grammert@C܂B")
            Exit Sub
        End If

        'FGW̃CjVCY
        Try
            'FIuWFNgCX^X
            objRecoContext = New SpSharedRecoContext
            'eCxg錾
            AddHandler objRecoContext.Hypothesis, AddressOf RecoContext_Hypothesis
            AddHandler objRecoContext.Recognition, AddressOf RecoContext_Recognition
            AddHandler objRecoContext.FalseRecognition, AddressOf RecoContext_FalseReco
            'Grammari@jIuWFNg쐬
            grammar = objRecoContext.CreateGrammar(1)

            'Dictaioni͔Fj͎gȂ̂InActiveɐݒ
            grammar.DictationLoad("", SpeechLoadOption.SLOStatic)
            grammar.DictationSetState(SpeechRuleState.SGDSInactive)
            'PF̃O}[t@Cǂݍ
            grammar.CmdLoadFromFile(FNM, SpeechLoadOption.SLODynamic)
            grammar.CmdSetRuleIdState(0, SpeechRuleState.SGDSInactive)
            'PFJn
            grammar.CmdSetRuleIdState(0, SpeechRuleState.SGDSActive)
            '͔FJn
            grammar.DictationSetState(SpeechRuleState.SGDSActive)

        Catch ex As Exception
            Throw New ApplicationException("InitSpeech" & Chr(10) & ex.ToString)
            Exit Sub
        End Try


    End Sub


    Public Sub RecoContext_Hypothesis(ByVal streamNumber As Integer, _
                                  ByVal streamPosition As Object, _
                                  ByVal Result As ISpeechRecoResult)

    End Sub


    Public Sub RecoContext_FalseReco(ByVal StreamNumber As Integer, _
                                     ByVal StreamPosition As Object, _
                                     ByVal Result As ISpeechRecoResult)

    End Sub

    Public Sub RecoContext_Recognition(ByVal StreamNumber As Integer, _
                      ByVal StreamPosition As Object, _
                      ByVal RecognitionType As SpeechRecognitionType, _
                      ByVal Result As ISpeechRecoResult)

        If RecoEnabled = False Then Exit Sub

        Dim recoword As String = Result.PhraseInfo.GetText(0, -1, True)

        Dim Val As Integer = Result.PhraseInfo.Properties.Item(0).Value
        Dim PNM As String = Result.PhraseInfo.Properties.Item(0).Name
        Dim CRNM As String = Result.PhraseInfo.Rule.Children.Item(0).Name
        Dim RecoCount As Integer = Result.PhraseInfo.Properties.Count

        Dim args As New SKSpeechEventArgs(RecoCount)
        args.RuleName = Result.PhraseInfo.Rule.Children.Item(0).Name

        Debug.WriteLine("1")
        Dim intloop As Integer
        For intloop = 0 To RecoCount - 1
            args.values(intloop) = Result.PhraseInfo.Properties.Item(intloop).Value
            args.ItemName(intloop) = Result.PhraseInfo.Properties.Item(intloop).Name
            args.Words(intloop) = Result.PhraseInfo.GetText(intloop, 1, True)
        Next

        RaiseEvent Recognition(Me, args)
        Debug.WriteLine("2")

    End Sub

End Class
